Index: sys/kern/kern_sendfile.c
===================================================================
--- sys/kern/kern_sendfile.c	(revision 312784)
+++ sys/kern/kern_sendfile.c	(working copy)
@@ -510,7 +510,7 @@ sendfile_getsock(struct thread *td, int s, struct
 	 * The socket must be a stream socket and connected.
 	 */
 	error = getsock_cap(td, s, cap_rights_init(&rights, CAP_SEND),
-	    sock_fp, NULL, NULL);
+	    sock_fp, NULL, NULL, DTYPE_SOCKET);
 	if (error != 0)
 		return (error);
 	*so = (*sock_fp)->f_data;
Index: sys/kern/sys_socket.c
===================================================================
--- sys/kern/sys_socket.c	(revision 312784)
+++ sys/kern/sys_socket.c	(working copy)
@@ -115,6 +115,28 @@ struct fileops	socketops = {
 	.fo_flags = DFLAG_PASSABLE
 };
 
+static fo_rdwr_t notconn_readwrite;
+static fo_ioctl_t sol_ioctl;
+static fo_poll_t sol_poll;
+extern fo_kqfilter_t sol_kqfilter;
+static fo_stat_t sol_stat;
+static fo_close_t sol_close;
+
+struct fileops	solistenops = {
+	.fo_read = notconn_readwrite,
+	.fo_write = notconn_readwrite,
+	.fo_truncate = invfo_truncate,
+	.fo_ioctl = sol_ioctl,
+	.fo_poll = sol_poll,
+	.fo_kqfilter = sol_kqfilter,
+	.fo_stat = sol_stat,		/* XXXGL: to do? */
+	.fo_close = sol_close,
+	.fo_chmod = invfo_chmod,
+	.fo_chown = invfo_chown,
+	.fo_sendfile = invfo_sendfile,
+	.fo_flags = DFLAG_PASSABLE
+};
+
 static int
 soo_read(struct file *fp, struct uio *uio, struct ucred *active_cred,
     int flags, struct thread *td)
@@ -153,6 +175,14 @@ soo_write(struct file *fp, struct uio *uio, struct
 }
 
 static int
+notconn_readwrite(struct file *fp, struct uio *uio, struct ucred *active_cred,
+    int flags, struct thread *td)
+{
+
+	return (ENOTCONN);
+}
+
+static int
 soo_ioctl(struct file *fp, u_long cmd, void *data, struct ucred *active_cred,
     struct thread *td)
 {
@@ -262,6 +292,61 @@ soo_ioctl(struct file *fp, u_long cmd, void *data,
 }
 
 static int
+sol_ioctl(struct file *fp, u_long cmd, void *data, struct ucred *active_cred,
+    struct thread *td)
+{
+	struct solisten *sol = fp->f_data;
+	int error = 0;
+
+	switch (cmd) {
+	case FIONBIO:
+		SOLISTEN_LOCK(sol);
+		if (*(int *)data)
+			sol->sol_state |= SS_NBIO;
+		else
+			sol->sol_state &= ~SS_NBIO;
+		SOLISTEN_UNLOCK(sol);
+		break;
+
+	case FIOASYNC:
+		SOLISTEN_LOCK(sol);
+		/* To be copied to child sockets. */
+		if (*(int *)data)
+			sol->sol_state |= SS_ASYNC;
+		else
+			sol->sol_state &= ~SS_ASYNC;
+		SOLISTEN_UNLOCK(sol);
+		break;
+
+	case FIOSETOWN:
+		error = fsetown(*(int *)data, &sol->sol_sigio);
+		break;
+
+	case FIOGETOWN:
+		*(int *)data = fgetown(&sol->sol_sigio);
+		break;
+
+	case SIOCSPGRP:
+		error = fsetown(-(*(int *)data), &sol->sol_sigio);
+		break;
+
+	case SIOCGPGRP:
+		*(int *)data = -fgetown(&sol->sol_sigio);
+		break;
+
+	case FIONREAD:
+	case FIONWRITE:
+	case FIONSPACE:
+	case SIOCATMARK:
+		/* XXXGL: find a better error code for these. ENOBUFS? */
+	default:
+		error = EINVAL;
+	}
+
+	return (error);
+}
+
+static int
 soo_poll(struct file *fp, int events, struct ucred *active_cred,
     struct thread *td)
 {
@@ -277,6 +362,22 @@ soo_poll(struct file *fp, int events, struct ucred
 }
 
 static int
+sol_poll(struct file *fp, int events, struct ucred *active_cred,
+    struct thread *td)
+{
+	struct solisten *sol = fp->f_data;
+#ifdef MAC
+	int error;
+
+							/* XXXGL */
+	error = mac_socket_check_poll(active_cred, (struct socket *)sol);
+	if (error)
+		return (error);
+#endif
+	return (solistenpoll(sol, events, fp->f_cred, td));
+}
+
+static int
 soo_stat(struct file *fp, struct stat *ub, struct ucred *active_cred,
     struct thread *td)
 {
@@ -314,6 +415,14 @@ soo_stat(struct file *fp, struct stat *ub, struct
 	return (*so->so_proto->pr_usrreqs->pru_sense)(so, ub);
 }
 
+static int
+sol_stat(struct file *fp, struct stat *ub, struct ucred *active_cred,
+    struct thread *td)
+{
+
+	return (EINVAL);
+}
+
 /*
  * API socket close on file pointer.  We call soclose() to close the socket
  * (including initiating closing protocols).  soclose() will sorele() the
@@ -336,6 +445,17 @@ soo_close(struct file *fp, struct thread *td)
 }
 
 static int
+sol_close(struct file *fp, struct thread *td)
+{
+	struct solisten *sol = fp->f_data;
+
+	fp->f_ops = &badfileops;
+	fp->f_data = NULL;
+
+	return (solistenclose(sol));
+}
+
+static int
 soo_fill_kinfo(struct file *fp, struct kinfo_file *kif, struct filedesc *fdp)
 {
 	struct sockaddr *sa;
@@ -695,7 +815,6 @@ soaio_process_sb(struct socket *so, struct sockbuf
 	sb->sb_flags &= ~SB_AIO_RUNNING;
 	SOCKBUF_UNLOCK(sb);
 
-	ACCEPT_LOCK();
 	SOCK_LOCK(so);
 	sorele(so);
 }
Index: sys/kern/uipc_accf.c
===================================================================
--- sys/kern/uipc_accf.c	(revision 312784)
+++ sys/kern/uipc_accf.c	(working copy)
@@ -162,28 +162,23 @@ accept_filt_generic_mod_event(module_t mod, int ev
 }
 
 int
-do_getopt_accept_filter(struct socket *so, struct sockopt *sopt)
+accept_filt_getopt(struct solisten *sol, struct sockopt *sopt)
 {
 	struct accept_filter_arg *afap;
 	int error;
 
 	error = 0;
-	afap = malloc(sizeof(*afap), M_TEMP,
-	    M_WAITOK | M_ZERO);
-	SOCK_LOCK(so);
-	if ((so->so_options & SO_ACCEPTCONN) == 0) {
+	afap = malloc(sizeof(*afap), M_TEMP, M_WAITOK | M_ZERO);
+	SOLISTEN_LOCK(sol);
+	if (sol->sol_accept_filter == NULL) {
 		error = EINVAL;
 		goto out;
 	}
-	if ((so->so_options & SO_ACCEPTFILTER) == 0) {
-		error = EINVAL;
-		goto out;
-	}
-	strcpy(afap->af_name, so->so_accf->so_accept_filter->accf_name);
-	if (so->so_accf->so_accept_filter_str != NULL)
-		strcpy(afap->af_arg, so->so_accf->so_accept_filter_str);
+	strcpy(afap->af_name, sol->sol_accept_filter->accf_name);
+	if (sol->sol_accept_filter_str != NULL)
+		strcpy(afap->af_arg, sol->sol_accept_filter_str);
 out:
-	SOCK_UNLOCK(so);
+	SOLISTEN_UNLOCK(sol);
 	if (error == 0)
 		error = sooptcopyout(sopt, afap, sizeof(*afap));
 	free(afap, M_TEMP);
@@ -191,35 +186,29 @@ out:
 }
 
 int
-do_setopt_accept_filter(struct socket *so, struct sockopt *sopt)
+accept_filt_setopt(struct solisten *sol, struct sockopt *sopt)
 {
 	struct accept_filter_arg *afap;
 	struct accept_filter *afp;
-	struct so_accf *newaf;
-	int error = 0;
+	char *accept_filter_str = NULL;
+	void *accept_filter_arg = NULL;
+	int error;
 
 	/*
 	 * Handle the simple delete case first.
 	 */
 	if (sopt == NULL || sopt->sopt_val == NULL) {
-		SOCK_LOCK(so);
-		if ((so->so_options & SO_ACCEPTCONN) == 0) {
-			SOCK_UNLOCK(so);
-			return (EINVAL);
+		SOLISTEN_LOCK(sol);
+		if (sol->sol_accept_filter != NULL) {
+			if (sol->sol_accept_filter->accf_destroy != NULL)
+				sol->sol_accept_filter->accf_destroy(sol);
+			if (sol->sol_accept_filter_str != NULL)
+				free(sol->sol_accept_filter_str, M_ACCF);
+			sol->sol_accept_filter = NULL;
+			sol->sol_accept_filter_arg = NULL;
+			sol->sol_accept_filter_str = NULL;
 		}
-		if (so->so_accf != NULL) {
-			struct so_accf *af = so->so_accf;
-			if (af->so_accept_filter != NULL &&
-				af->so_accept_filter->accf_destroy != NULL) {
-				af->so_accept_filter->accf_destroy(so);
-			}
-			if (af->so_accept_filter_str != NULL)
-				free(af->so_accept_filter_str, M_ACCF);
-			free(af, M_ACCF);
-			so->so_accf = NULL;
-		}
-		so->so_options &= ~SO_ACCEPTFILTER;
-		SOCK_UNLOCK(so);
+		SOLISTEN_UNLOCK(sol);
 		return (0);
 	}
 
@@ -227,8 +216,7 @@ int
 	 * Pre-allocate any memory we may need later to avoid blocking at
 	 * untimely moments.  This does not optimize for invalid arguments.
 	 */
-	afap = malloc(sizeof(*afap), M_TEMP,
-	    M_WAITOK);
+	afap = malloc(sizeof(*afap), M_TEMP, M_WAITOK);
 	error = sooptcopyin(sopt, afap, sizeof *afap, sizeof *afap);
 	afap->af_name[sizeof(afap->af_name)-1] = '\0';
 	afap->af_arg[sizeof(afap->af_arg)-1] = '\0';
@@ -241,28 +229,18 @@ int
 		free(afap, M_TEMP);
 		return (ENOENT);
 	}
-	/*
-	 * Allocate the new accept filter instance storage.  We may
-	 * have to free it again later if we fail to attach it.  If
-	 * attached properly, 'newaf' is NULLed to avoid a free()
-	 * while in use.
-	 */
-	newaf = malloc(sizeof(*newaf), M_ACCF, M_WAITOK |
-	    M_ZERO);
+
 	if (afp->accf_create != NULL && afap->af_name[0] != '\0') {
 		size_t len = strlen(afap->af_name) + 1;
-		newaf->so_accept_filter_str = malloc(len, M_ACCF,
-		    M_WAITOK);
-		strcpy(newaf->so_accept_filter_str, afap->af_name);
+		accept_filter_str = malloc(len, M_ACCF, M_WAITOK);
+		strcpy(accept_filter_str, afap->af_name);
 	}
 
 	/*
-	 * Require a listen socket; don't try to replace an existing filter
-	 * without first removing it.
+	 * Don't try to replace an existing filter without first removing it.
 	 */
-	SOCK_LOCK(so);
-	if (((so->so_options & SO_ACCEPTCONN) == 0) ||
-	    (so->so_accf != NULL)) {
+	SOLISTEN_LOCK(sol);
+	if (sol->sol_accept_filter != NULL) {
 		error = EINVAL;
 		goto out;
 	}
@@ -273,25 +251,19 @@ int
 	 * can't block.
 	 */
 	if (afp->accf_create != NULL) {
-		newaf->so_accept_filter_arg =
-		    afp->accf_create(so, afap->af_arg);
-		if (newaf->so_accept_filter_arg == NULL) {
+		accept_filter_arg = afp->accf_create(sol, afap->af_arg);
+		if (accept_filter_arg == NULL) {
 			error = EINVAL;
 			goto out;
 		}
 	}
-	newaf->so_accept_filter = afp;
-	so->so_accf = newaf;
-	so->so_options |= SO_ACCEPTFILTER;
-	newaf = NULL;
+	sol->sol_accept_filter = afp;
+	sol->sol_accept_filter_arg = accept_filter_arg;
+	sol->sol_accept_filter_str = accept_filter_str;
 out:
-	SOCK_UNLOCK(so);
-	if (newaf != NULL) {
-		if (newaf->so_accept_filter_str != NULL)
-			free(newaf->so_accept_filter_str, M_ACCF);
-		free(newaf, M_ACCF);
-	}
-	if (afap != NULL)
-		free(afap, M_TEMP);
+	SOLISTEN_UNLOCK(sol);
+	if (accept_filter_str != NULL)
+		free(accept_filter_str, M_ACCF);
+	free(afap, M_TEMP);
 	return (error);
 }
Index: sys/kern/uipc_debug.c
===================================================================
--- sys/kern/uipc_debug.c	(revision 312784)
+++ sys/kern/uipc_debug.c	(working copy)
@@ -84,10 +84,6 @@ db_print_sooptions(short so_options)
 		db_printf("%sSO_DEBUG", comma ? ", " : "");
 		comma = 1;
 	}
-	if (so_options & SO_ACCEPTCONN) {
-		db_printf("%sSO_ACCEPTCONN", comma ? ", " : "");
-		comma = 1;
-	}
 	if (so_options & SO_REUSEADDR) {
 		db_printf("%sSO_REUSEADDR", comma ? ", " : "");
 		comma = 1;
@@ -458,15 +454,8 @@ db_print_socket(struct socket *so, const char *soc
 		db_print_protosw(so->so_proto, "so_proto", indent);
 
 	db_print_indent(indent);
-	db_printf("so_head: %p   ", so->so_head);
-	db_printf("so_incomp first: %p   ", TAILQ_FIRST(&so->so_incomp));
-	db_printf("so_comp first: %p\n", TAILQ_FIRST(&so->so_comp));
-
-	db_print_indent(indent);
+	db_printf("so_listen: %p   ", so->so_listen);
 	/* so_list skipped */
-	db_printf("so_qlen: %u   ", so->so_qlen);
-	db_printf("so_incqlen: %u   ", so->so_incqlen);
-	db_printf("so_qlimit: %u   ", so->so_qlimit);
 	db_printf("so_timeo: %d   ", so->so_timeo);
 	db_printf("so_error: %d\n", so->so_error);
 
@@ -478,6 +467,29 @@ db_print_socket(struct socket *so, const char *soc
 	db_print_sockbuf(&so->so_snd, "so_snd", indent);
 }
 
+static void
+db_print_solisten(struct solisten *sol, const char *socketname, int indent)
+{
+
+	db_print_indent(indent);
+	db_printf("%s at %p\n", socketname, sol);
+
+	indent += 2;
+
+	db_print_indent(indent);
+	db_printf("sol_incomp first: %p   ", TAILQ_FIRST(&sol->sol_incomp));
+	db_printf("sol_comp first: %p\n", TAILQ_FIRST(&sol->sol_comp));
+	db_printf("sol_qlen: %d   ", sol->sol_qlen);
+	db_printf("sol_incqlen: %d   ", sol->sol_incqlen);
+	db_printf("sol_qlimit: %d   ", sol->sol_qlimit);
+	db_printf(")\n");
+
+	db_print_indent(indent);
+	db_printf("sol_options: 0x%x (", sol->sol_options);
+	db_print_sooptions(sol->sol_options);
+	db_printf(")\n");
+}
+
 DB_SHOW_COMMAND(socket, db_show_socket)
 {
 	struct socket *so;
@@ -491,6 +503,19 @@ DB_SHOW_COMMAND(socket, db_show_socket)
 	db_print_socket(so, "socket", 0);
 }
 
+DB_SHOW_COMMAND(solisten, db_show_solisten)
+{
+	struct solisten *sol;
+
+	if (!have_addr) {
+		db_printf("usage: show solisten <addr>\n");
+		return;
+	}
+	sol = (struct solisten *)addr;
+
+	db_print_solisten(sol, "solisten", 0);
+}
+
 DB_SHOW_COMMAND(sockbuf, db_show_sockbuf)
 {
 	struct sockbuf *sb;
